'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = function (_ref) {
  var t = _ref.types;

  var className = void 0;

  return {
    name: 'babel-plugin-component-identification',
    visitor: {
      ClassDeclaration: function ClassDeclaration(_ref2) {
        var name = _ref2.node.id.name;

        className = name;
      },
      ReturnStatement: function ReturnStatement(path) {
        var argument = path.node.argument;

        if (argument && argument.type !== 'JSXElement') {
          return;
        }

        var _path$getFunctionPare = path.getFunctionParent(),
            parentId = _path$getFunctionPare.node.id,
            functionalComponent = _path$getFunctionPare.parent;

        var isClassInstanceMethod = parentId && parentId.name;
        var isClassRenderMethod = className && parentId && parentId.name === 'render';
        var isFunctionalComponent = functionalComponent && functionalComponent.id;
        var identity = void 0;

        if (isClassRenderMethod) {
          identity = className;
        } else if (isFunctionalComponent) {
          identity = functionalComponent.id.name;
        } else if (isClassInstanceMethod) {
          identity = parentId.name;
        } else {
          // last ditch effort at looking for a named component
          // might just want to ignore these entirely
          var _path$findParent = path.findParent(function (pp) {
            return pp.isVariableDeclaration();
          }),
              _path$findParent$node = _slicedToArray(_path$findParent.node.declarations, 1),
              variableDeclarationName = _path$findParent$node[0].name;

          identity = variableDeclarationName;
        }

        if (argument && identity) {
          var newAttributes = [t.jSXAttribute(t.jSXIdentifier('data-component-id'), t.stringLiteral(identity))];

          if (argument) {
            var _argument$openingElem;

            (_argument$openingElem = argument.openingElement.attributes).push.apply(_argument$openingElem, newAttributes);
          }
        }
      }
    }
  };
};